
""" A superclass for buildroots """

# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
# Copyright 2004 Dries Verachtert

# normally you don't use this class but a subclass which implements 
# these functions
# for example: YumBasedBuildRoot

# example usage:
# fc3br = BlaBlaBuildRoot(cfg,'fedora-3-i386-core')
# result = fc3br.prepareRoot()
# result = fc3br.buildRpm(SpecFile('a.spec'),'1.fc3.rf')
# result = fc3br.prepareRoot()
# result = fc3br.buildRpm(SpecFile('b.spec'),'1.fc3.rf')
# result = fc3br.prepareRoot()
# result = fc3br.buildRpm(SpecFile('c.spec'),'1.fc3.rf')
# normally you should check the result each time

from log4py import Logger
#from specfile import SpecFile

class BuildRoot:
    # this will already set certain variables
    def __init__(self,buildRootTag):
        self.__cat = Logger().get_instance(self)
        self.__cat.debug("start")
        self._setBuildRootTag(buildRootTag)
    
    def _setBuildRootTag(self,buildRootTag):
        self.__buildRootTag = buildRootTag
    
        
    def getBuildRootTag(self):
        return self.__buildRootTag
    
    # this cleans up this root
    # depends on the implementation
    # the result is a BuildRootResult object
    def cleanRoot(self):
        self.__cat.debug("start")
    
    # this prepares a buildroot so it can be used for building an rpm
    # this calls cleanRoot if needed
    # this creates the buildRoot from scratch if needed
    # the result is a BuildRootResult object
    def prepareRoot(self):
        self.__cat.debug("start")
       
    # the argument is a SlaveCommand object
    # the result is a BuildRootResult object
    def buildRpm(self,command):
        self.__cat.debug("start")
        
    # rpms is an array of strings (names of rpms)
    # this is used for installing the buildrequirements
    # this only works on a root which has been prepared already
    # otherwise you get a lot of errors (so use prepareRoot first)
    # the result is a BuildRootResult object
    def installRpms(self,rpms):
        self.__cat.debug("start")
        
