#!/usr/bin/python

""" Contains the information about a files source of spec files """

# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
# Copyright 2004 Dries Verachtert

import ConfigParser, os, posixpath, sys
sys.path.append("pydar")
sys.path.append(".")
from log4py import Logger
from specrepository import SpecRepository
#from specrepositoryfactory import SpecRepositoryFactory

class FilesBasedSpecRepository(SpecRepository):
    # name: ascii name, for example 'rpmforge'
    # type: a constant, can be one of "SVN", "CVS", "FILES"
    def __init__(self, name, rootdirectory):
        SpecRepository.__init__(self, name, rootdirectory)
        self.__cat = Logger().get_instance(self)
        self._setType(SpecRepository.TYPE_FILES)
        self.__cat.debug("initialized")
        
    def getUpdateCommand(self):
        return ""
    
    def getSpecFileVersion(self, specRepoSpecFile):
        fullPath = self.getRootDirectory() + "/" + specRepoSpecFile.getSubDir() + "/" + specRepoSpecFile.getFileName()
        self.__cat.debug("fullPath: " + fullPath)
        return str(os.path.getmtime(fullPath)) + "-" + str(os.path.getsize(fullPath))
