#!/usr/bin/python

""" A wrapper around a user defined function/script in a seperate .py file which moves the rpms and/or buildlog """

# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
# Copyright 2004 Dries Verachtert

import sys
from log4py import Logger
from callablescript import CallableScript

# The function should return True if the rpms and/or buildlog are moved, False otherwise
# this should make it possible to move the rpms to some directory structure which can be used 
# for other tools to create a nice website about the rpms
# todo: check if repoview can be plugged in this way

class MoveCommandResultsScript(CallableScript):
    def runScript(self,aCommand, commanddir):
        return self._getMethod().__call__(aCommand, commanddir)
