#!/usr/bin/python

""" helper class for calling functions on the master """

# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
# Copyright 2004 Dries Verachtert


import getopt, os, sys
sys.path.append("/usr/share/pydar/pydar")
sys.path.append("pydar")
from xmlrpclib import Server
from log4py import Logger

class PydarClient:
    def __init__(self,buildmasterurl):
        self.__cat = Logger().get_instance(self)
        self.buildmasterurl = buildmasterurl
        self.__cat.debug("initialised, buildmasterurl=" + self.buildmasterurl)
        
    def getSpecRepositoriesUpdateCommands(self,userId,password):
        myserverclient = Server(self.buildmasterurl)
        retval = myserverclient.getSpecRepositoriesUpdateCommands(userId,password)
        return retval

    def updateAllSpecRepositoriesFileLists(self,userId,password):
        myserverclient = Server(self.buildmasterurl)
        retval = myserverclient.updateAllSpecRepositoriesFileLists(userId,password)
        return retval

    def buildSpecByPath(self,userId,password,specRepoName, specFilePath, toEmail, distroArchTag, priority, target):
        myserverclient = Server(self.buildmasterurl)
        retval = myserverclient.buildSpecByPath(userId,password, specRepoName, specFilePath, toEmail, distroArchTag, priority, target)
        return retval

    def testBuildSpecByPath(self,userId, password, fileContents, toEmail, distroArchTag, priority):
        myserverclient = Server(self.buildmasterurl)
        retval = myserverclient.testBuildSpecByPath(userId,password, fileContents, toEmail, distroArchTag, priority)
        return retval
    
    def callUpdateSiteScript(self,userId,password,specRepoName):
        myserverclient = Server(self.buildmasterurl)
        retval = myserverclient.callUpdateSiteScript(userId,password, specRepoName)
        return retval
    
    def getNumberOfNotYetStartedCommands(self, userId, password):
        myserverclient = Server(self.buildmasterurl)
        retval = myserverclient.getNumberOfNotYetStartedCommands(userId,password)
        return retval

    def autoQueue(self,userId, password, targetName, mailTo, priority, specRepoName, distroArchTag):
        myserverclient = Server(self.buildmasterurl)
        retval = myserverclient.autoQueue(userId, password, targetName, mailTo, priority, specRepoName, distroArchTag)
        return retval

    def callMoveCommandResultsScript(self,userId,password, commandId):
        myserverclient = Server(self.buildmasterurl)
        retval = myserverclient.callMoveCommandResultsScript(userId,password, commandId)
        return retval
    
    def updateTargetFileList(self, userId, password, targetName, mailTo):
        myserverclient = Server(self.buildmasterurl)
        retval = myserverclient.updateTargetFileList(userId, password, targetName, mailTo)
        return retval
