
""" Reads some tags from a rpm file """

# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
# Copyright 2004 Dries Verachtert

# This class can be used for reading the values of certain tags from a rpm file

import re, os, commands
from log4py import Logger
from tagsfile import TagsFile

# currently the standard tags are written in uppercase
# result can be found in the hashes rpmforgetags and standardtags
# a rpm has no rpmforgetags

class RpmFileTags(TagsFile):
    # rpmfile: a path to a rpm file like /a/b/c.spec
    # defineargs: a string which can be used on the commandline 
    # like '--define "fc2 1"'
    def __init__(self, rpmfile, defineargs):
        TagsFile.__init__(self,defineargs, " -p ", rpmfile)