#!/usr/bin/python

""" Creates types of spec repository objects """

# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
# Copyright 2004 Dries Verachtert

from log4py import Logger
from svnbasedspecrepository import SvnBasedSpecRepository
from cvsbasedspecrepository import CvsBasedSpecRepository
from filesbasedspecrepository import FilesBasedSpecRepository
from specrepository import SpecRepository

## SINGLETON: so use the getInstance() method

class SpecRepositoryFactory:
    __myInstance = None
    # TODO, make static
    def __init__(self):
        if SpecRepositoryFactory.__myInstance != None:
            raise Exception("use getInstance() of SpecRepositoryFactory")
        else:
            SpecRepositoryFactory.__myInstance = self

    #@classmethod
    def getInstance(cls):
        if cls.__myInstance == None:
            unused = SpecRepositoryFactory()
        return cls.__myInstance
    getInstance = classmethod(getInstance)

    def createSpecRepository(self,name, type, rootdirectory):
        if type == SpecRepository.TYPE_SVN:
            return SvnBasedSpecRepository(name, rootdirectory)
        if type == SpecRepository.TYPE_CVS:
            return CvsBasedSpecRepository(name, rootdirectory)
        if type == SpecRepository.TYPE_FILES:
            return FilesBasedSpecRepository(name, rootdirectory)
        # oops, error
        raise Exception, "unknown type " + str(type)
