#!/usr/bin/python

""" Creates types of storage objects """

# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
# Copyright 2004 Dries Verachtert

from log4py import Logger
from postgresqlstorage import PostgresqlStorage
#from memorystorage import MemoryStorage

## SINGLETON: so use the getInstance() or immediately the getStorage() method

class StorageFactory:
    __myInstance = None
    __myStorageInstance = None
    
    def __init__(self):
        if StorageFactory.__myInstance != None:
            raise Exception("use getInstance() of StorageFactory")
        else:
            StorageFactory.__myInstance = self

    #@classmethod
    def getInstance(cls):
        if cls.__myInstance == None:
            unused = StorageFactory()
        return cls.__myInstance
    getInstance = classmethod(getInstance)

    def getStorage(cls):
        if cls.__myStorageInstance == None:
            cls.__myStorageInstance = PostgresqlStorage()
            #cls.__myStorageInstance = MemoryStorage()
        return cls.__myStorageInstance
    getStorage = classmethod(getStorage)
    
